import React from 'react';
import ReactDom from 'react-dom';
import ajax from 'jquery/src/ajax/xhr.js';
import $ from 'jquery/src/ajax';
import { Form,Radio, Icon, Button, Input, Select, Spin, Table, Switch, message, DatePicker, Checkbox ,Modal, Upload ,Popconfirm} from 'antd';
import NewService from "./addService.jsx";
import moment from 'moment';
import '../../userMangagement.less';
import {intentProgress,transactionProgress,contractProgress,projectProgress,orderType, orderStage, orderState,paymentState, projectState,orderChannel, approvedState, lock,paymentMethod,transactionChannel} from '../../../../dataDic.js';
import {getIntentProgress,getTransactionProgress,getProjectState,getContractProgress,getProjectProgress,splitUrl,getOrderType,getOrderStage,getOrderState,getPaymentState,getOrderChannel,getApprovedState,getLock,getPaymentMethod,getTransactionChannel} from '../../../../tools.js';

const MyService=Form.create()(React.createClass({
	loadData(pageNo) {
        this.state.data = [];
        this.setState({
            loading: true
        });
        $.ajax({
            method: "post",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/listServiceOrder',
            data: {
                pageNo: pageNo || 1,
                pageSize: this.state.pagination.pageSize,
                buyerName:this.state.customerName,
                startDate: this.state.releaseDate[0],
				endDate: this.state.releaseDate[1],
				projectStage:this.state.projectProgress,
				liquidationStatus:this.state.settlementState, //结算
				orderStatus:this.state.orderStatusSearch,
				orderChannel:this.state.orderChannelSearch,
				intention:this.state.intentOrder?1:0,
				formal:this.state.formalOrder?1:0
            },
            success: function (data) {
                let theArr = [];
                if (!data.data) {
                    if (data.error && data.error.length) {
                        message.warning(data.error[0].message);
                    };
                } else {
                    for (let i = 0; i < data.data.list.length; i++) {
                        let thisdata = data.data.list[i];
                        theArr.push({
                             key: i,
	                         id: thisdata.id,
	                         orderNo: thisdata.orderNo,//订单编号
	                         orderType:thisdata.orderType,//订单类型
	                         orderStatus:thisdata.orderStatus,
	                         liquidationStatus:thisdata.liquidationStatus,
	                         createTime:thisdata.createTime,
	                         buyerName:thisdata.buyerName,
	                         signTotalAmount:thisdata.signTotalAmount,
	                         projectStage:thisdata.projectStage,
	                         approval:thisdata.approval,
	                         orderChannel:thisdata.orderChannel,
	                         salesmanName:thisdata.salesmanName,
	                         active:thisdata.active,
                        });
                    };
                    this.state.pagination.current = data.data.pageNo;
                    this.state.pagination.total = data.data.totalCount;
                };
                if(!data.data.list.length){
					this.state.pagination.current=0
					this.state.pagination.total=0
				}
                this.setState({
                	pageNo:pageNo,
                    dataSource: theArr,
                    pagination: this.state.pagination,
                    selectedRowKeys:[],
                    signBillVisible:false
                });
            }.bind(this),
        }).always(function () {
            this.setState({
                loading: false
            });
        }.bind(this));
    },
    getInitialState() {
        return {
        	datauser:{},
            selectedRowKeys: [],
            releaseDate: [],
            signBillState:false,
            signBillVisible:false,
            selectedRows: [],
            searchMore: true,
            loading: false,
            intentOrder:true,
            formalOrder:true,
            pagination: {
                defaultCurrent: 1,
                defaultPageSize: 10,
                showQuickJumper: true,
                pageSize: 10,
                onChange: function (page) {
                    this.loadData(page);
                }.bind(this),
                showTotal: function (total) {
                    return '共' + total + '条数据';
                }
            },
            columns: [
                {
                    title: '订单编号',
                    dataIndex: 'orderNo',
                    key: 'orderNo'
                }, {
                    title: '订单类型',
                    dataIndex: 'orderType',
                    key: 'orderType',
                    render:text=>{return getOrderType(text)}
                }, {
                    title: '下单时间',
                    dataIndex: 'createTime',
                    key: 'createTime'
                },{
                    title: '订单客户',
                    dataIndex: 'buyerName',
                    key: 'buyerName'
                }, {
                    title: '实际下单金额',
                    dataIndex: 'signTotalAmount',
                    key: 'signTotalAmount'
                },{
                    title: '结算状态',
                    dataIndex: 'liquidationStatus',
                    key: 'liquidationStatus',
                    render:text=>{return getPaymentState(text)}
                }, {
                    title: '订单状态',
                    dataIndex: 'orderStatus',
                    key: 'orderStatus',
                    render:text=>{return getOrderState(text)}
                }, {
                    title: '项目状态',
                    dataIndex: 'projectStage',
                    key: 'projectStage',
                    render:text=>{return getProjectState(text)}
                }, {
                    title: '是否特批',
                    dataIndex: 'approval',
                    key: 'approval',
                    render:text=>{return text==2?'已特批':'未特批'}
                },{
                    title: '订单渠道',
                    dataIndex: 'orderChannel',
                    key: 'orderChannel',
                    render:text=>{return getOrderChannel(text)}
                },{
                    title: '财务负责人',
                    dataIndex: 'salesmanName',
                    key: 'salesmanName'
                },
                {
                    title: '操作',
                    dataIndex: 'active',
                    key: 'active',
                    render: (text, record, index) => {
						return <div>
							{text.confirmIntention&&<Popconfirm title={'请确认您是否受理来自【'+record.buyerName+'】发起的服务意向订单？'} onConfirm={(e)=>{this.admissibleOrderOk(record)}} onCancel={(e)=>{this.admissibleOrderCancel(record)}} okText="同意" cancelText="拒绝">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="primary">受理意向</Button>                 
							</Popconfirm>}
							{text.applySign&&<Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation(),this.signBill(record)}} type="primary">签单</Button> }                
							{text.applyForCancel&&<Popconfirm title={'请确认您是否取消客户【'+record.buyerName+'】的服务订单，订单取消将导致业务终止！'} onConfirm={(e)=>{this.cancelOrder(record)}} okText="确认" cancelText="取消">
								<Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="danger">取消订单</Button>                 
							</Popconfirm>}
							{text.applyRevoke&&<Popconfirm title={'请确认您是否作废客户【'+record.buyerName+'】的服务订单，订单作废将导致订单失效！'} onConfirm={(e)=>{this.scrapOrder(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="danger">作废</Button>                 
							</Popconfirm>}
							{text.applyLock &&<Popconfirm title={'请确认您是否锁定客户【'+record.buyerName+'】的服务订单，订单锁定将导致订单暂停！'} onConfirm={(e)=>{this.lockOrder(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="danger">锁定<Icon type="lock" /></Button>                 
							</Popconfirm>}
							{text.applyUnLock&&<Popconfirm title={'请确认您是否解锁客户【'+record.buyerName+'】的服务订单，订单解锁将导致订单正常！'} onConfirm={(e)=>{this.unlockOrder(record)}} okText="确认" cancelText="取消">
							    <Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation()}} type="primary">解锁<Icon type="unlock" /></Button>                 
							</Popconfirm>}
							{record.liquidationStatus<=1?<Button style={{marginRight:'5px'}} onClick={(e) =>{ e.stopPropagation(),this.paymentMoney(record)}} type="primary">支付</Button>:''}             
                        </div>
					}
                }
            ],
            dataSource: [],
        };
    },
     //支付
    paymentMoney(record){
    	this.setState({
    		kid:record.orderNo,
    		payment:'',
    		paymentVisible:true
    	})
    },
    paymentCancel(){
    	this.setState({
    		paymentVisible:false
    	})
    },
    //支付保存
    payment(){
    	if(!this.state.payment){
    		message.warning('请输入支付金额！');
    		return;
    	};
    	this.setState({
            selectedRowKeys: [],
            loading: true,
            showDesc:false
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/testPay',
            data: {
            	orderNo:this.state.kid,
            	payAmount:this.state.payment
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('支付成功！');
                this.paymentCancel();
                this.loadData(this.state.pageNo);
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
        }.bind(this));
    },
    //受理订单
    admissibleOrderOk(e){
    	this.admissibleOrder(e,true)
    },
    admissibleOrderCancel(e){
    	this.admissibleOrder(e,false)
    },
    admissibleOrder(record,index) {
        this.setState({
        	signBillVisible:false,
            selectedRowKeys: [],
            loading: true,
            userDetaile:false
        });
        $.ajax({
            method: "POST",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/confirmIntention',
            data: {
            	orderNo:record.orderNo,
            	confirm:index
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('操作成功！');
                this.setState({
                    loading: false,
                    showDesc:false
                });
            } else {
                message.warning(data.error[0].message);
                this.setState({
                	showDesc:true
                })
            };
            this.loadData(this.state.pageNo);
        }.bind(this));
    },
    //取消订单
    cancelOrder(e){
    	this.operation(e,3)
    },
    //作废订单
    scrapOrder(e){
    	this.operation(e,2)
    },
    //锁定订单
    lockOrder(e){
    	this.operation(e,0)
    },
    //解锁订单
    unlockOrder(e){
    	this.operation(e,1)
    },
    //签单
    signBill(ids){
    	this.setState({
    		uid:ids,
    		signBillVisible:true
    	})
    },
    componentWillMount() {
        this.loadData();
    },
    tableRowClick(record, index) {
    	this.state.userDetaile=true;
        this.state.datauser = record;
        this.setState({
        	signBillVisible:false,
        	signBillState:true,
            showDesc: true
        });
    },
    //列表各种骚操作
    operation(record,index) {
        this.setState({
            selectedRowKeys: [],
            loading: true,
            showDesc:false
        });
        $.ajax({
            method: "get",
            dataType: "json",
            crossDomain: false,
            url: globalConfig.context + '/api/admin/order/lockOrRevokeOrder',
            data: {
            	orderNo:record.orderNo,
            	operatorType:index
            }
        }).done(function (data) {
            if (!data.error.length) {
                message.success('操作成功！');
                this.setState({
                    loading: false,
                });
            } else {
                message.warning(data.error[0].message);
            };
            this.loadData(this.state.pageNo);
        }.bind(this));
    },
    addClick() {
    	this.state.userDetaile=false;
        this.setState({
        	signBillVisible:false,
            showDesc: true
        });
    },
    closeDesc(e, s) {
    	this.state.userDetaile=false;
        this.state.showDesc = e;
        if (s) {
            this.loadData(this.state.pageNo);
        };
    },
    searchSwitch() {
		this.setState({
			signBillVisible:false,
			searchMore: !this.state.searchMore
		});
	},
    search() {
    	this.setState({
    		signBillVisible:false
    	})
        this.loadData();
    },
    reset() {
    	this.setState({
    		signBillVisible:false
    	})
    	this.state.customerName='';
    	this.state.releaseDate[0] = undefined;
		this.state.releaseDate[1] = undefined;
		this.state.projectProgress = undefined;
		this.state.settlementState = undefined;
		this.state.orderStatusSearch = undefined;
		this.state.orderChannelSearch = undefined;
		this.state.formalOrder=true;
		this.state.intentOrder=true;
        this.loadData();       
    },
    render() {
    	const FormItem = Form.Item;
    	const formItemLayout = {
			labelCol: { span: 8 },
			wrapperCol: { span: 14 },
		};
        const rowSelection = {
            selectedRowKeys: this.state.selectedRowKeys,
            onChange: (selectedRowKeys, selectedRows) => {
	                this.setState({
	                    selectedRows: selectedRows.slice(-1),
	                    selectedRowKeys: selectedRowKeys.slice(-1)
	                }); 
            },
            onSelectAll: (selected, selectedRows, changeRows) => {
			   this.setState({
			   		selectedRowKeys:[]
			   })
			},
        };
        const hasSelected = this.state.selectedRowKeys.length > 0;
        const { RangePicker } = DatePicker;
        return (
            <div className="user-content" >
                <div className="content-title">
                	<span style={{fontSize:'16px'}}>我的科技服务订单</span>	
	                <div className="user-search">
	                    <Input placeholder="客户名称" style={{width:'150px'}}
	                        value={this.state.customerName}
	                        onChange={(e) => { this.setState({ customerName: e.target.value }); }} />
	                    <RangePicker
		                        value={[this.state.releaseDate[0] ? moment(this.state.releaseDate[0]) : null,
		                        this.state.releaseDate[1] ? moment(this.state.releaseDate[1]) : null]}
		                        onChange={(data, dataString) => { this.setState({ releaseDate: dataString }); }} />     
	                    <Button type="primary" onClick={this.search} style={{marginLeft:'10px'}}>搜索<Icon type="search" /></Button>
	                    <Button onClick={this.reset}>重置 <Icon type="reload" /></Button>
	                    <span style={{marginLeft:'10px',marginRight:'20px'}}>更多搜索<Switch defaultChecked={false} onChange={this.searchSwitch} /></span>    
	                    <Button type="primary" className="addButton" onClick={this.addClick} >开单<Icon type="plus" /></Button>
	                </div>
	                <div className='clearfix' style={{marginTop:'5px'}}>
	                  <div className="search-more" style={this.state.searchMore ? { display: 'none' } : {}}>   
	                  		<Checkbox checked={this.state.intentOrder} onChange={(e)=>{this.setState({intentOrder:!this.state.intentOrder})}}>意向订单</Checkbox>
	                  		<Checkbox checked={this.state.formalOrder} onChange={(e)=>{this.setState({formalOrder:!this.state.formalOrder})}}>正式订单</Checkbox>
	                  		<Select placeholder="订单状态"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.orderStatusSearch}
	                            onChange={(e) => { this.setState({ orderStatusSearch: e }) }}>
	                            {
                                    orderState.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="结算状态"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.settlementState}
	                            onChange={(e) => { this.setState({ settlementState: e }) }}>
	                            {
                                    paymentState.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="项目进度"
	                            style={{ width: 150 ,marginRight:'10px'}}
	                            value={this.state.projectProgress}
	                            onChange={(e) => { this.setState({ projectProgress: e }) }}>
	                            {
                                    projectState.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                        <Select placeholder="订单渠道"
	                            style={{ width: 150 }}
	                            value={this.state.orderChannelSearch}
	                            onChange={(e) => { this.setState({ orderChannelSearch: e }) }}>
	                            {
                                    orderChannel.map(function (item) {
                                            return <Select.Option key={item.value} >{item.key}</Select.Option>
                                    })
                                }
	                        </Select>
	                    </div>
	                </div>
	                <div className="patent-table">
	                    <Spin spinning={this.state.loading}>
	                        <Table columns={this.state.columns}
	                            dataSource={this.state.dataSource}
	                            rowSelection={rowSelection}
	                            pagination={this.state.pagination}
	                            onRowClick={this.tableRowClick} />
	                    </Spin>
	                </div>
	                <NewService
	                	uid={this.state.uid}
	                	signBillVisible={this.state.signBillVisible}
	                    signBillState={this.state.signBillState}
	                	operation={this.operation}
	                	admissibleOrder={this.admissibleOrder}
	                    userDetaile={this.state.userDetaile}
	                    datauser={this.state.datauser}
	                    showDesc={this.state.showDesc}
	                    closeDesc={this.closeDesc} />
	            </div >
	             <Modal maskClosable={false} visible={this.state.paymentVisible}
                        onOk={this.paymentCancel} onCancel={this.paymentCancel}
                        width='550px'
                        title='支付详情'                     
                        footer=''
                        className="admin-desc-content">
			            <Form layout="horizontal" id="demand-form">
			                <Spin spinning={this.state.loading}>
		                        <div className="clearfix">
	                        	    <FormItem className="half-middle"
			                            {...formItemLayout}
			                            label="支付金额" >
		                    			<Input value={this.state.payment} onChange={(e)=>{this.setState({payment:e.target.value})}} style={{width:'220px'}} />
		                    			<span className="mandatory">*</span>
			                    	</FormItem>
			                    	<Button type="primary" onClick={this.payment}>支付</Button>
			                    	<Button onClick={this.paymentCancel}>取消</Button>
		                        </div>
			                </Spin>
			            </Form >
			        </Modal>
            </div>
        );
    }
}));

export default MyService;

